// Misja w nadprzestrzeń C++14/17, program z paragrafu   3.19

#include <iostream>
using namespace std;

#define STYL_NOWY true 				// lub false (gdy stary)					 // `1

#if STYL_NOWY == false 				// dotychczasowy sposób C++11
// –––––––––––––––––––––––––––––––––––––––––––––––––––––––––––––––
namespace mars {					 									// `2
	// –––––––––––––––––––––––
	namespace prototyp{ 													// `3
		void funkcjaA() {		 											// `4
			cout << __func__ << " Wersja mars::prototypowa"<< endl;
		}
	}
	//––––––––––––––––––––––––
	namespace docelowa 													// `5
	{
		void funkcjaA() {
			cout << __func__ << " Wersja mars::docelowa" << endl;
		}
	}
}
// –––––––––––––––––––––––––––––––––––––––––––––––––––––––––––––––
// jakieś inne deklaracje													// `6
int 		zmienna1;
double 	zmienna2;
// –––––––––––––––––––––––––––––––––––––––––––––––––––––––––––––––
// postanawiamy dodać kolejną zagnieżdżoną namespace wtorek, a w niej nową funkcję
// –––––––––––––––––––––––––––––––––––––––––––––––––––––––––––––––
namespace mars{ 														// `7
	namespace prototyp { 													// `8
		namespace wtorek { 	// tworzymy zagnieżdżoną podprzestrzeń (wtorek) 		// `9
			void funkcjaA()	// w niej nową funkcję
			{
				cout << __func__ << " Wersja mars::prototyp::wtorek" << endl;
			}
		}
	}
}
# else 		// czyli nowy STYL C++17 #######################################
//–––––––––––––––––––––––––––––––––––––––––––––––––––––––––––––––
namespace mars::prototyp 												// `10
{
	void funkcjaA() { 														// `11
		cout << __func__ << " Wersja mars::prototypowa"<< endl;
	}
}
//–––––––––––––––––––––––––––––––––––––––––––––––––––––––––––––––
namespace mars::docelowa 												// `12
{
	void funkcjaA() {	 													// `13
		cout << __func__ << " Wersja mars::docelowa" << endl;
	}
}
//*******************************************************************
int 		zmienna1;														// `14
double 	zmienna2;
// –––––––––––––––––––––––––––––––––––––––––––––––––––––––––––––––
// postanawiamy dodać kolejną zagnieżdżoną namespace wtorek, a w niej nową funkcję
// –––––––––––––––––––––––––––––––––––––––––––––––––––––––––––––––
namespace mars::prototyp::wtorek 	// tworzymy nową zagnieżdżoną podprzestrzeń: wtorek // `15
{
	void funkcjaA()	 			// w niej umieszczamy nową funkcję
	{
		cout << __func__ << " Wersja mars::prototyp::wtorek" << endl;
	}
}
//–––––––––––––––––––––––––––––––––––––––––––––––––––––––––––––––
# endif	// koniec kompilacji warunkowej (z nowym stylem zagnieżdżania)

int zmienna_globalna; 		// jakaś tam definicja
//*******************************************************************
int main()
{
	mars::prototyp::funkcjaA();	 											// `16
	mars::docelowa::funkcjaA();
	mars::prototyp::wtorek::funkcjaA();

	namespace cn = mars::docelowa; 										// `17
	// namespace cn = mars::prototyp;
	// namespace cn = mars::prototyp::wtorek;

	cout << "Obecnie pracujemy z funkcjami przestrzeni: \n";
	cn::funkcjaA(); 														// `18
}
